package it.unibo.lbedogni.notificationservice;

import android.content.ComponentName;
import android.content.Context;
import android.content.Intent;
import android.content.ServiceConnection;
import android.os.AsyncTask;
import android.os.Bundle;
import android.os.IBinder;
import android.support.v7.app.AppCompatActivity;
import android.util.Log;
import android.view.View;
import android.widget.Button;
import android.widget.TextView;

public class NotificationService extends AppCompatActivity implements View.OnClickListener {

    boolean serviceIsStarted = false;

    Button btnNotificationService;
    Button btnService;
    Button btnIntentService;
    Button btnBadService;
    Button btnGoodService;
    Button btnNotify;
    Button btnAsync;

    private DelayTask dTask;

    TextView tvCaller;
    TextView tvAsyncCounter;

    private BoundService lService;


    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_notification_service);

        btnNotificationService = (Button)findViewById(R.id.btnNotificationService);
        btnService = (Button)findViewById(R.id.btnService);
        btnIntentService = (Button)findViewById(R.id.btnIntentService);
        btnBadService = (Button)findViewById(R.id.btnBadService);
        btnGoodService = (Button)findViewById(R.id.btnGoodService);
        btnNotify = (Button)findViewById(R.id.btnNotify);
        btnAsync = (Button)findViewById(R.id.btnAsync);

        tvCaller = (TextView)findViewById(R.id.tvCaller);
        tvAsyncCounter = (TextView)findViewById(R.id.tvAsyncCounter);

        btnNotificationService.setOnClickListener(this);
        btnService.setOnClickListener(this);
        btnIntentService.setOnClickListener(this);
        btnBadService.setOnClickListener(this);
        btnGoodService.setOnClickListener(this);
        btnNotify.setOnClickListener(this);
        btnAsync.setOnClickListener(this);

        Intent i = getIntent();
        String caller = i.getStringExtra("CALLER");
        tvCaller.setText(caller);

    }

    @Override
    public void onClick(View v) {
        if (v == btnNotificationService) {
            Intent i = new Intent(getApplicationContext(), notifyService.class);
            startService(i);
            btnNotificationService.setBackgroundColor(getResources().getColor(R.color.colorAccent));
        } else if (v == btnService) {
            connectService();
            btnService.setBackgroundColor(getResources().getColor(R.color.colorAccent));
        } else if (v == btnIntentService) {
            Intent i = new Intent(getApplicationContext(), MyIntentService.class);
            startService(i);
            btnIntentService.setBackgroundColor(getResources().getColor(R.color.colorAccent));
        } else if (v == btnBadService) {
            Intent i = new Intent(getApplicationContext(),BadServiceCounter.class);
            startService(i);
            btnBadService.setBackgroundColor(getResources().getColor(R.color.colorAccent));
        } else if (v == btnGoodService) {
            Intent i = new Intent(getApplicationContext(),GoodServiceCounter.class);
            startService(i);
            btnGoodService.setBackgroundColor(getResources().getColor(R.color.colorAccent));
        } else if (v == btnNotify) {
            lService.getDate();
        } else if (v == btnAsync) {
            dTask = new DelayTask();
            dTask.execute(1000);
            btnAsync.setBackgroundColor(getResources().getColor(R.color.colorAccent));
        }
    }

    private ServiceConnection mConnection = new ServiceConnection() {

        @Override
        public void onServiceConnected(ComponentName arg0, IBinder bind) {
            BoundService.SimpleBinder sBinder = (BoundService.SimpleBinder) bind;
            lService = sBinder.getService();
        }

        @Override
        public void onServiceDisconnected(ComponentName arg0) {

        }

    };

    private void connectService() {
        Intent intent = new Intent(this,BoundService.class);
        bindService(intent,mConnection, Context.BIND_AUTO_CREATE);
        serviceIsStarted = true;
    }

    private class DelayTask extends AsyncTask<Integer, Integer, Void> {

        @Override
        protected Void doInBackground(Integer... parameters) {
            // Retrieve the starting time
            int time = parameters[0];
            Log.d("ASYNC", "EXECUTE "+time);
            while (time >0) {
                Log.d("ASYNC", "EXECUTE2");
                try {
                    Thread.sleep(10);
                } catch (InterruptedException e) {
                    e.printStackTrace();
                }
                time--;
                publishProgress(time);
            }

            return null;
        }

        @Override
        protected void onProgressUpdate(Integer... values) {
            super.onProgressUpdate(values);
            tvAsyncCounter.setText(String.valueOf(values[0]));
        }
    }
}
